require 'observer'

class Employee
  include Observable
  attr_reader :name
  attr_reader :title, :salary

  def initialize(name, title, salary)
    super()
    @name, @title, @salary = name, title, salary
#    @observers = []
  end
  
  def salary=(new_salary)
    @salary = new_salary
    changed
    notify_observers(self)
  end

  def add_observer(observer)
    @observers << observer
  end

  def del_observer(observer)
    @observers.delete observer
  end
end

class Payroll
  def update(changed_employee)
    puts("#{changed_employee.name}のために小切手を切ります!")
    puts("彼の給料はいま#{changed_employee.salary}です!")
  end
end

class TaxMan
  def update(changed_employee)
    puts("#{changed_employee.name}に新しい税金の請求書を送ります!")
  end
end

fred = Employee.new("Fred Flintstone", "Crane Operator", 30000.0)

payroll = Payroll.new
fred.add_observer(payroll)
tax_man = TaxMan.new
fred.add_observer(tax_man)
fred.salary = 35000.0


